pipeline {
  environment {
      registry = "10.30.3.239:5000/joseespinozac/angular-app"
      dockerImage = ''
      dockerContainerName = 'angular-container'
  }

  agent any
  stages {
    stage('Instalar dependencias') {
      steps {
        sh 'npm install';
      }
    }

    stage('Analisis de codigo estatico') {
        steps { sh 'npm run sonar' }
    }

    stage('Pruebas de unidad') {
        steps {
          sh 'echo Aqui se ejecutan las pruebas de unidad'
        }
    }

    stage('Contruir imagen') {
        steps{
            sh "docker image inspect $registry >/dev/null 2>&1 && docker rmi $registry || echo No image to delete"
            script{
                    dockerImage = docker.build(registry, "-f Dockerfile .")
                }
            }

    }
    stage('Registrar imagen') {
        steps {
            script {
                docker.withRegistry('http://10.30.3.239:5000', 'docker-cred') {
                    dockerImage.push()
                }
            }

        }

    }
    stage('Despliegue de aplicación') {
        steps {
            sh "docker inspect $dockerContainerName >/dev/null 2>&1 && docker stop $dockerContainerName || echo No container to stop"
            sh "docker inspect $dockerContainerName >/dev/null 2>&1 && docker rm $dockerContainerName || echo No container to remove"
            sh "docker container run --name $dockerContainerName -p 8082:80 -d $registry"
        }
    }
  }
}
